<?php

/*************************************************************************
 * Who Read This Thread - XenConcept (c) 2017
 * All Rights Reserved.
 **************************************************************************
 * This file is subject to the terms and conditions defined in the Licence
 * Agreement available at Try it like it buy it :)
 *************************************************************************/

namespace XenConcept\WhoReadThisThread\Widget;

use XF\Widget\AbstractWidget;

class OnlineReaders extends AbstractWidget
{

    public function render()
    {
        /** @var \XenConcept\WhoReadThisThread\XF\Entity\Thread $thread */
        $contextParams = $this->contextParams;
        $thread = $contextParams['thread'];
        $threadId = $thread['thread_id'];
        $forum   = $thread->Forum;
        $options = \XF::options();

        if (!$options->xc_who_read_this_thread_enable)
        {
            return '';
        }

        if (!in_array($forum->node_id, $options->xc_who_read_this_thread_allowed_nodes))
        {
            return '';
        }

        if (!$thread->canViewThreadOnlineReaders())
        {
            return '';
        }

        $sessionActivityRepo = $this->getSessionActivityRepo();
        $onlineReaders = $sessionActivityRepo->findForOnlineListViewingThread($threadId);

        $totalOnlineReaders = $onlineReaders->total();
        $onlineReaders = $onlineReaders->fetch();

        $viewParams = [

            'onlineReaders' => $onlineReaders,
            'totalOnlineReaders' => $totalOnlineReaders

        ];

        return $this->renderer('xc_who_read_this_thread_widget_online_readers', $viewParams);
    }

    /**
     * @return \XenConcept\WhoReadThisThread\XF\Repository\SessionActivity
     */
    protected function getSessionActivityRepo()
    {
        return $this->repository('XF:SessionActivity');
    }
}