<?php

/*************************************************************************
 * Who Read This Thread - XenConcept (c) 2017
 * All Rights Reserved.
 **************************************************************************
 * This file is subject to the terms and conditions defined in the Licence
 * Agreement available at Try it like it buy it :)
 *************************************************************************/

namespace XenConcept\WhoReadThisThread\Widget;

use XF\Widget\AbstractWidget;

class WhoReadThisThread extends AbstractWidget
{

    public function render()
    {
        $contextParams = $this->contextParams;

        /** @var \XenConcept\WhoReadThisThread\XF\Entity\Thread $thread */
        $thread  = $this->contextParams['thread'];
        $forum   = $thread->Forum;
        $options = \XF::options();

        if (!$options->xc_who_read_this_thread_enable)
        {
            return '';
        }

        if (!in_array($forum->node_id, $options->xc_who_read_this_thread_allowed_nodes))
        {
            return '';
        }

        if (!$thread->canViewThreadReaders())
        {
            return '';
        }

        $threadRepo = $this->getThreadRepo();
        $threadReaders = $threadRepo->findReadersByThreadId($thread->thread_id, $thread->user_id);

        $threadReadersTotal = $threadReaders->total();
        $threadReaders = $threadReaders->fetch();


        $viewParams = [
            'thread' => $thread,
            'threadReadersTotal' => $threadReadersTotal,
            'threadReaders' => $threadReaders,
            'position' => $contextParams['position']
        ];

        return $this->renderer('xc_who_read_this_thread_widget', $viewParams);
    }

    /**
     * @return \XenConcept\WhoReadThisThread\XF\Repository\Thread
     */
    protected function getThreadRepo()
    {
        return  $this->repository('XF:Thread');
    }

}