<?php

/*************************************************************************
 * Who Read This Thread - XenConcept (c) 2017
 * All Rights Reserved.
 **************************************************************************
 * This file is subject to the terms and conditions defined in the Licence
 * Agreement available at Try it like it buy it :)
 *************************************************************************/

namespace XenConcept\WhoReadThisThread\XF\Repository;

class Thread extends XFCP_Thread
{

    public function findReadersByThreadId($threadId, $userId)
    {
        $finder = $this->finder('XF:ThreadRead');

        $finder
            ->where('thread_id', $threadId)
            ->where('user_id', '!=', $userId)
            ->with('User');


        $options = \XF::options();

        if ($options->xc_who_read_this_thread_exclude_user_banned)
        {
            $finder
                ->where('User.is_banned', 0);
        }


        $displayDays = $options->xc_xc_who_read_this_thread_display_limit;

        if ($displayDays)
        {
            $dateLimit = \XF::$time - $displayDays * 86400;

            $finder
                ->where('thread_read_date', '>', $dateLimit);
        }



        return $finder;
    }
}